#pragma once

// *********************************************************
// 
// This class is NOT THREAD SAFE
//
// If you have multiple UI threads use some kind of locking.
//
// *********************************************************

class CLeoThemeHelper  
{
public:
	CLeoThemeHelper();
	virtual ~CLeoThemeHelper();

	bool IsAvailable();

	bool CacheBackgroundTabThemeDialog(HWND hWnd);

	// Returns TRUE iff it was enabled.
	bool EnableTabThemeDialogTexture(HWND hWnd);

	// You have to call EnableThemeDialogTexture and have Windows erase the background in order to get
	// "transparent" controls if version 6 common-controls are enabled. This function will draw over
	// the background below the point where it doesn't tile properly, if the window is large enough to need it.
	// In fact the controls are not transparent and any control which isn't an opaque square and is below
	// the height of the non-tiling bitmap will have a border around it showing what Windows would have drawn
	// before we drew over it.
	// I've been unable to find a way to make the version 6 common-controls paint over an arbitrary background.
	// They draw boxes around themselves with what they *think* is the parent window's background, ignoring the
	// fact that the parent window has a handler to draw its background...
	// i.e. They seem to draw the background themselves rather than ask the parent window to do it.
	//  The whole point of all of this background drawing is that the stupid texture doesn't tile so we make
	// a version which does and draw it ourselves.
	// Roll on the XP service pack and prey they fix all this.
	// It's 2002 and we still don't have decent support for resizable dialogs; in fact it just got WORSE.
	// Why is all this theme stuff based on bitmaps anyway? Shouldn't we be moving to vector-based graphics
	// and shaders now instead of this crap which only works for certain size displays and, worse,
	// fixed-size windows??
	// 2005 Update: Did the XP SP2 service pack improve the awful theming system for tab controls? Did it fCHEESY PEAS!
	void EraseExtraBackgroundTabThemeDialog(HWND hWnd, HDC hDC, RECT &rcClient);

protected:
	typedef HANDLE  (__stdcall *OPENTHEMEDATA_PTR)(HWND hwnd, LPCWSTR pszClassList);
	typedef HRESULT (__stdcall *CLOSETHEMEDATA_PTR)(HANDLE hTheme);
	typedef HRESULT (__stdcall *DRAWTHEMEBACKGROUND_PTR)(HANDLE hTheme, HDC hdc, int iPartId, int iStateId, const RECT *pRect, OPTIONAL const RECT *pClipRect);
	typedef HRESULT (__stdcall *GETTHEMEPARTSIZE_PTR)(HANDLE hTheme, HDC hdc, int iPartId, int iStateId, OPTIONAL RECT *prc, enum THEMESIZE eSize, OUT SIZE *psz);
	typedef HRESULT (__stdcall *ENABLETHEMEDIALOGTEXTURE_PTR)(HWND hwnd, DWORD dwFlags);

	HMODULE m_hmodUxThemeDLL;

	OPENTHEMEDATA_PTR				m_fOpenThemeData;
	CLOSETHEMEDATA_PTR				m_fCloseThemeData;
	DRAWTHEMEBACKGROUND_PTR			m_fDrawThemeBackground;
	GETTHEMEPARTSIZE_PTR			m_fGetThemePartSize;
	ENABLETHEMEDIALOGTEXTURE_PTR	m_fEnableThemeDialogTexture;

	SIZE m_sizePart;
	HBITMAP m_hbmpDIB;
};
