#pragma once

//#define NJR_FILEWRAPDEBUG

class CWin32IOWrapper
{
protected:
	bool m_bThrowExceptions;

public:
	CWin32IOWrapper();
	virtual ~CWin32IOWrapper();

	virtual size_t read(void *ptr, size_t size, size_t nmemb) = 0;
	virtual int    seek(long offset, int whence) = 0;
	virtual long   tell() = 0;

	virtual int    getc();
	virtual char * gets(char *string, int n);
	virtual int    getInt();
	virtual float  getFloat();

	bool GetThrowExceptions();
	void SetThrowExceptions(bool bThrow);
	virtual bool CanSeek() = 0;
};

/*
class CWin32IOBufferedStreamWrapper : public CWin32IOWrapper
{
protected:
	IStream *m_pStream;
	char *m_buffer;
	unsigned long m_ulBufferSize;
	unsigned long m_ulPosition;

public:
	CWin32IOBufferedStreamWrapper(IStream *pStream);
	virtual ~CWin32IOBufferedStreamWrapper();

	virtual size_t read(void *ptr, size_t size, size_t nmemb);
	virtual int    seek(long offset, int whence);
	virtual long   tell();

	virtual bool CanSeek();
};
*/

class CWin32IOStreamWrapper : public CWin32IOWrapper
{
protected:
	IStream *m_pStream;
	bool m_bCanSeek;

public:
	CWin32IOStreamWrapper(IStream *pStream, bool bCanSeek);
	virtual ~CWin32IOStreamWrapper();

	virtual size_t read(void *ptr, size_t size, size_t nmemb);
	virtual int    seek(long offset, int whence);
	virtual long   tell();

	virtual bool CanSeek();
};

class CWin32IOFileWrapper : public CWin32IOWrapper
{
protected:
	HANDLE m_hFile;
	HANDLE m_hAbortEvent;

#ifdef NJR_FILEWRAPDEBUG
	HANDLE m_hDebugFile;
#endif

public:
	CWin32IOFileWrapper(const char *szName, HANDLE hAbortEvent);
	virtual ~CWin32IOFileWrapper();

	virtual size_t read(void *ptr, size_t size, size_t nmemb);
	virtual int    seek(long offset, int whence);
	virtual long   tell();

	virtual bool CanSeek();

	bool IsHandleValid();
};

class CWin32IOJpegSource : public jpeg_source_mgr
{
protected:
	enum { WIJS_BUFFER_SIZE = 32768 };

	CWin32IOWrapper *m_pFile;
	bool m_bStartOfFile;
	JOCTET *m_buffer;

protected:
	static void impl_init_source(j_decompress_ptr cinfo);
	static boolean impl_fill_input_buffer(j_decompress_ptr cinfo);
	static void impl_skip_input_data(j_decompress_ptr cinfo, long num_bytes);
	static void impl_term_source(j_decompress_ptr cinfo);

public:
	CWin32IOJpegSource(CWin32IOWrapper *pFile);
	virtual ~CWin32IOJpegSource();
};
