#pragma once

extern "C"
{
	__declspec(dllexport) BOOL DVP_IdentifyA(LPVIEWERPLUGININFOA lpVPInfo);
	__declspec(dllexport) BOOL DVP_IdentifyFileA(HWND hWnd,LPTSTR lpszName,LPVIEWERPLUGINFILEINFOA lpVPFileInfo,HANDLE hAbortEvent);
	__declspec(dllexport) BOOL DVP_IdentifyFileStreamA(HWND hWnd,LPSTREAM lpStream,LPTSTR lpszName,LPVIEWERPLUGINFILEINFOA lpVPFileInfo,DWORD dwStreamFlags);
	__declspec(dllexport) HBITMAP DVP_LoadBitmapA(HWND hWnd,LPTSTR lpszName,LPVIEWERPLUGINFILEINFOA lpVPFileInfo,LPSIZE lpszDesiredSize,HANDLE hAbortEvent);
	__declspec(dllexport) HBITMAP DVP_LoadBitmapStreamA(HWND hWnd,LPSTREAM lpStream,LPTSTR lpszName,LPVIEWERPLUGINFILEINFOA lpVPFileInfo,LPSIZE lpszDesiredSize,DWORD dwStreamFlags);
	__declspec(dllexport) HWND DVP_Configure(HWND hWndParent,HWND hWndNotify,DWORD dwNotifyData);
};

DWORD64 getOpusVersionNumber();

bool copyVersionNumber(DWORD *pdwHigh, DWORD *pdwLow, TCHAR *szItemName, BYTE *pLang, const LPVOID pVerData);
bool copyVersionString(TCHAR *szDestBuffer, UINT uiDestBufferSize, TCHAR *szItemName, BYTE *pLang, const LPVOID pVerData);


// dwPrivateData
enum
{
	PRIVATEDATA_IMAGETYPE_DWORD = 0
};

enum
{
	PDIT_UNKNOWN = 0,
	PDIT_DCRAW,
	PDIT_JP2,
	PDIT_TGA,
	PDIT_PNM,
	PDIT_RAS,
	PDIT_TIF,
};

#pragma pack(push,1)

struct RasterfileHeader
{
	DWORD ras_magic;
	DWORD ras_width;
	DWORD ras_height;
	DWORD ras_depth;
	DWORD ras_length;
	DWORD ras_type;
	DWORD ras_maptype;
	DWORD ras_maplength;

	RasterfileHeader(const unsigned char *pb)
	{
		const RasterfileHeader *pMixedUp = reinterpret_cast<const RasterfileHeader *>(pb);

		ras_magic     = SWAPLONG(pMixedUp->ras_magic);
		ras_width     = SWAPLONG(pMixedUp->ras_width);
		ras_height    = SWAPLONG(pMixedUp->ras_height);
		ras_depth     = SWAPLONG(pMixedUp->ras_depth);
		ras_length    = SWAPLONG(pMixedUp->ras_length);
		ras_type      = SWAPLONG(pMixedUp->ras_type);
		ras_maptype   = SWAPLONG(pMixedUp->ras_maptype);
		ras_maplength = SWAPLONG(pMixedUp->ras_maplength);
	}
};

struct JP2IhdrBox
{
	DWORD height;
	DWORD width;
	WORD numcmpts;
	BYTE bpc;
	BYTE comptype;
	BYTE csunk;
	BYTE ipr;

	JP2IhdrBox(const unsigned char *pb)
	{
		const JP2IhdrBox *pMixedUp = reinterpret_cast<const JP2IhdrBox *>(pb);

		*this = *pMixedUp;

		width = SWAPLONG(width);
		height = SWAPLONG(height);
		numcmpts = SWAPSHORT(numcmpts);
	}
};

struct TGAFileHeader
{
	BYTE	bIDLength;
	BYTE	bColorMapType;
	BYTE	bImageType;
	WORD	wColorMapFirstEntryIndex;
	WORD	wColorMapLength;
	BYTE	bColorMapEntrySize;
	WORD	wOriginX;
	WORD	wOriginY;
	WORD	wImageWidth;
	WORD	wImageHeight;
	BYTE	bPixelDepth;
	BYTE	bImageDescriptor;

//	int		AlphaBits() { return (int)(bImageDescriptor&0xf); }
//	int		ImageOrder() { return (int)((bImageDescriptor>>4)&3); }
};

struct TGAFileFooter
{
	DWORD	dwExtensionAreaOffset;
	DWORD	dwDeveloperDirectoryOffset;
	char	chSignature[18];
};

struct TGAFileExtensionArea
{
	WORD		wExtensionSize;
	char		chAuthorName[41];
	char		chAuthorComments[324];
	WORD		wMonth;
	WORD		wDay;
	WORD		wYear;
	WORD		wHour;
	WORD		wMinute;
	WORD		wSecond;
	char		chJobNameID[41];
	WORD		wJobTimeHours;
	WORD		wJobTimeMinutes;
	WORD		wJobTimeSeconds;
	char		chSoftwareID[41];
	WORD		wSoftwareVersionNumber;
	BYTE		bSoftwareVersionLetter;
	COLORREF	dwKeyColor;
	WORD		wPixelRatioNum;
	WORD		wPixelRatioDen;
	WORD		wGammaNum;
	WORD		wGammaDen;
	DWORD		dwColorCorrectionOffset;
	DWORD		dwPostageStampOffset;
	DWORD		dwScanLineOffset;
	BYTE		bAttributesType;
};

#pragma pack(pop)

#define TGAIMAGE_NONE				0
#define TGAIMAGE_COLORMAPPEDRAW		1
#define TGAIMAGE_TRUECOLORRAW		2
#define TGAIMAGE_BWRAW				3
#define TGAIMAGE_COLORMAPPEDRLE		9
#define TGAIMAGE_TRUECOLORRLE		10
#define TGAIMAGE_BWRLE				11

#define TGAORDER_BOTTOMLEFT			0
#define TGAORDER_BOTTOMRIGHT		1
#define TGAORDER_TOPLEFT			2
#define TGAORDER_TOPRIGHT			3

